---
title: XMLHttpRequest.upload
slug: Web/API/XMLHttpRequest/upload
tags:
  - AJAX
  - API
  - Monitoring XMLHttpRequest
  - Property
  - Read-only
  - Reference
  - Sending Files
  - Uploading
  - XHR
  - XHR Uploads
  - XMLHttpRequest
  - XMLHttpRequest Uploads
  - XMLHttpRequestUpload
  - upload
---
<div>{{APIRef('XMLHttpRequest')}}</div>

<p><span class="seoSummary">The {{domxref("XMLHttpRequest")}} <code>upload</code> property returns an {{domxref("XMLHttpRequestUpload")}} object that can be observed to monitor an upload's progress.</span> It is an opaque object, but because it's also an {{domxref("XMLHttpRequestEventTarget")}}, event listeners can be attached to track its process.</p>

<p>The following events can be triggered on an upload object and used to monitor the upload:</p>

<table class="standard-table">
 <tbody>
  <tr>
   <td class="header">Event</td>
   <td class="header">Event listener</td>
   <td class="header">Description</td>
  </tr>
  <tr>
   <td>{{event("loadstart")}}</td>
   <td>{{domxref("XMLHttpRequest.onloadstart", "onloadstart")}}</td>
   <td>The upload has begun.</td>
  </tr>
  <tr>
   <td>{{event("progress")}}</td>
   <td>{{domxref("XMLHttpRequest.onprogress", "onprogress")}}</td>
   <td>Periodically delivered to indicate the amount of progress made so far.</td>
  </tr>
  <tr>
   <td>{{event("abort")}}</td>
   <td>{{domxref("XMLHttpRequest.onabort", "onabort")}}</td>
   <td>The upload operation was aborted.</td>
  </tr>
  <tr>
   <td>{{event("error")}}</td>
   <td>{{domxref("XMLHttpRequest.onerror", "onerror")}}</td>
   <td>The upload failed due to an error.</td>
  </tr>
  <tr>
   <td>{{event("load")}}</td>
   <td>{{domxref("XMLHttpRequest.onload", "onload")}}</td>
   <td>The upload completed successfully.</td>
  </tr>
  <tr>
   <td>{{event("timeout")}}</td>
   <td>{{domxref("XMLHttpRequest.ontimeout", "ontimeout")}}</td>
   <td>The upload timed out because a reply did not arrive within the time interval specified by the {{domxref("XMLHttpRequest.timeout")}}.</td>
  </tr>
  <tr>
   <td>{{event("loadend")}}</td>
   <td>{{domxref("XMLHttpRequest.onloadend", "onloadend")}}</td>
   <td>The upload finished. This event does not differentiate between success or failure, and is sent at the end of the upload regardless of the outcome. Prior to this event, one of <code>load</code>, <code>error</code>, <code>abort</code>, or <code>timeout</code> will already have been delivered to indicate why the upload ended.</td>
  </tr>
 </tbody>
</table>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('XMLHttpRequest', '#the-upload-attribute')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>WHATWG living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XMLHttpRequest.upload")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a></li>
 <li><a href="/en-US/docs/Web/API/File_Handle_API">FileHandle API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
</ul>
